using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UnityEngine;
using System.Collections;
using UnityEngine.Events;

namespace CSSticks
{
    public class CSSticks
    {
        public static void Main()
        {
          CategoryBuilder.Create("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns", "All shooting sticks from there.", ModAPI.LoadSprite("categoryicon.png"));
          CategoryBuilder.Create("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Knives", "All hitting sticks from there.", ModAPI.LoadSprite("categoryicon1.png"));
          CategoryBuilder.Create("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Specials", "All special sticks from there.", ModAPI.LoadSprite("categoryicon2.png"));

/*                                        NAVIGATION
           29 - Knives
           660 - Pistols
           1666 - Shotguns
           2120 - Submachine Guns
           2745 - Sniper Rifles
           3164 - Rifles
           3985 - Machine Guns
*/

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Knife"),
                  NameOverride = "Bayonet <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "If you love a WW2 knife - YOU are an oldschooler! \n<color=purple>(4 Skins)</color>",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Knives"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/bayonet icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Knives/bayonet_collider.png", 23);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Knives/bayonet.png", 4.4f),
                          ModAPI.LoadSprite("Skins/BayonetSkins/bayonet skin1.png", 8.8f),
                          ModAPI.LoadSprite("Skins/BayonetSkins/bayonet skin2.png", 8.8f),
                          ModAPI.LoadSprite("Skins/BayonetSkins/bayonet skin3.png", 8.8f),
                      };

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.15f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Knife"),
                  NameOverride = "Bowie Knife <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "We are going down: now we are playing with knives of the 19th century! \n<color=purple>(3 Skins)</color>",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Knives"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/bowie icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Knives/bowie_collider.png", 15.5f);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Knives/bowie.png", 3.3f),
                          ModAPI.LoadSprite("Skins/BowieSkins/bowie skin1.png", 6.6f),
                          ModAPI.LoadSprite("Skins/BowieSkins/bowie skin2.png", 6.6f),
                      };

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Knife"),
                  NameOverride = "Butterfly Knife <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Jump like <<Tiger>>, hit like <<Wasp>>, cut like <<Butterfly>>. \n<color=purple>(4 Skins)</color>",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Knives"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/butterfly icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Knives/butterfly_collider.png", 19);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Knives/butterfly.png", 4),
                          ModAPI.LoadSprite("Skins/ButterflySkins/butterfly skin1.png", 8),
                          ModAPI.LoadSprite("Skins/ButterflySkins/butterfly skin2.png", 8),
                          ModAPI.LoadSprite("Skins/ButterflySkins/butterfly skin3.png", 8),
                      };

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.112f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Knife"),
                  NameOverride = "Classic <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Classic knife from the classic game. \n<color=purple>(3 Skins)</color>",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Knives"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/classic icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Knives/classic_collider.png", 18);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Knives/classic.png", 3.6f),
                          ModAPI.LoadSprite("Skins/ClassicSkins/classic skin1.png", 7.2f),
                          ModAPI.LoadSprite("Skins/ClassicSkins/classic skin2.png", 7.2f),
                      };

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Knife"),
                  NameOverride = "Daggers <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "You stick your fingers into it and check the opponent's skin for plasticity. \n<color=purple>(3 Skins)</color>",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Knives"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/daggers icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Knives/daggers_collider.png", 4.5f);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Knives/daggers.png", 4),
                          ModAPI.LoadSprite("Skins/DaggersSkins/daggers skin1.png", 8),
                          ModAPI.LoadSprite("Skins/DaggersSkins/daggers skin2.png", 8),
                      };

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.05f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Knife"),
                  NameOverride = "Falchion <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "No, calm down! It's not a medieval knife. \n<color=purple>(3 Skins)</color>",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Knives"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/falchion icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Knives/falchion_collider.png", 16);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Knives/falchion.png", 4),
                          ModAPI.LoadSprite("Skins/FalchionSkins/falchion skin1.png", 8),
                          ModAPI.LoadSprite("Skins/FalchionSkins/falchion skin2.png", 8),
                      };

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.064f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Knife"),
                  NameOverride = "Flip <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Fun fact: the knife is called a flip one, but it's too big for that. \n<color=purple>(3 Skins)</color>",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Knives"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/flip icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Knives/flip_collider.png", 18);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Knives/flip.png", 3.8f),
                          ModAPI.LoadSprite("Skins/FlipSkins/flip skin1.png", 7.6f),
                          ModAPI.LoadSprite("Skins/FlipSkins/flip skin2.png", 7.6f),
                      };
                      Instance.FixColliders();

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.074f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Knife"),
                  NameOverride = "Gut <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "A good knife to open the next bottle of beer. \n<color=purple>(3 Skins)</color>",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Knives"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/gut icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Knives/gut_collider.png", 4.05f);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Knives/gut.png", 3.8f),
                          ModAPI.LoadSprite("Skins/GutSkins/gut skin1.png", 7.6f),
                          ModAPI.LoadSprite("Skins/GutSkins/gut skin2.png", 7.6f),
                      };
                      Instance.FixColliders();

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.08f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Knife"),
                  NameOverride = "Huntsman <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "All universal is bad! Except for hunting. \n<color=purple>(3 Skins)</color>",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Knives"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/huntsman icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Knives/huntsman_collider.png", 4);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Knives/huntsman.png", 3.5f),
                          ModAPI.LoadSprite("Skins/HuntsmanSkins/huntsman skin1.png", 7),
                          ModAPI.LoadSprite("Skins/HuntsmanSkins/huntsman skin2.png", 7),
                      };
                      Instance.FixColliders();

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.128f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Knife"),
                  NameOverride = "Karambit <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Plus of curved knives: they can hit the enemy on the back while standing in front of him! \n<color=purple>(4 Skins)</color>",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Knives"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/karambit icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Knives/karambit_collider.png", 6);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Knives/karambit.png", 5.5f),
                          ModAPI.LoadSprite("Skins/KarambitSkins/karambit skin1.png", 11),
                          ModAPI.LoadSprite("Skins/KarambitSkins/karambit skin2.png", 11),
                          ModAPI.LoadSprite("Skins/KarambitSkins/karambit skin3.png", 11),
                      };
                      Instance.FixColliders();

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.09f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Knife"),
                  NameOverride = "M9 Bayonet <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "A modern version of an old knife (now YOU are not an oldschooler). \n<color=purple>(3 Skins)</color>",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Knives"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/M9_bayonet icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Knives/M9_bayonet_collider.png", 4.7f);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Knives/M9_bayonet.png", 4.4f),
                          ModAPI.LoadSprite("Skins/M9BayonetSkins/M9_bayonet skin1.png", 8.8f),
                          ModAPI.LoadSprite("Skins/M9BayonetSkins/M9_bayonet skin2.png", 8.8f),
                      };
                      Instance.FixColliders();

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.13f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Knife"),
                  NameOverride = "Navaja <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "- I want to Spain - Why? We have Spain at home - Spain at home:.... \n<color=purple>(3 Skins)</color>",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Knives"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/navaja icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Knives/navaja_collider.png", 3.9f);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Knives/navaja.png", 3.6f),
                          ModAPI.LoadSprite("Skins/NavajaSkins/navaja skin1.png", 7.2f),
                          ModAPI.LoadSprite("Skins/NavajaSkins/navaja skin2.png", 7.2f),
                      };
                      Instance.FixColliders();

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.055f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Knife"),
                  NameOverride = "Nomad <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "I don't know what size it should be. \n<color=purple>(3 Skins)</color>",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Knives"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/nomad icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Knives/nomad_collider.png", 4f);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Knives/nomad.png", 3.7f),
                          ModAPI.LoadSprite("Skins/NomadSkins/nomad skin1.png", 7.4f),
                          ModAPI.LoadSprite("Skins/NomadSkins/nomad skin2.png", 7.4f),
                      };
                      Instance.FixColliders();

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.065f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Knife"),
                  NameOverride = "Paracord <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "The more holes - the cooler (probably)! \n<color=purple>(3 Skins)</color>",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Knives"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/paracord icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Knives/paracord_collider.png", 4.1f);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Knives/paracord.png", 3.8f),
                          ModAPI.LoadSprite("Skins/ParacordSkins/paracord skin1.png", 7.6f),
                          ModAPI.LoadSprite("Skins/ParacordSkins/paracord skin2.png", 7.6f),
                      };
                      Instance.FixColliders();

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.095f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Knife"),
                  NameOverride = "Skeleton Knife <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Knife straight from a crypt. \n<color=purple>(3 Skins)</color>",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Knives"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/skeleton icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Knives/skeleton_collider.png", 4.3f);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Knives/skeleton.png", 4),
                          ModAPI.LoadSprite("Skins/SkeletonSkins/skeleton skin1.png", 8),
                          ModAPI.LoadSprite("Skins/SkeletonSkins/skeleton skin2.png", 8),
                      };
                      Instance.FixColliders();

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.115f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Knife"),
                  NameOverride = "Special Forces Knife <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "A tactical knife is cool in that you can attach a sight, a butt and a laser to it. \n<color=purple>(2 Skins)</color>",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Knives"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/special_knife icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Knives/special_knife_collider.png", 4.1f);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Knives/special_knife.png", 3.8f),
                          ModAPI.LoadSprite("Skins/GoldSkins/gold_special_knife.png", 3.8f),
                      };
                      Instance.FixColliders();

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.085f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Knife"),
                  NameOverride = "Stiletto <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Can you imagine how it cut? \n<color=purple>(3 Skins)</color>",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Knives"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/stiletto icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Knives/stiletto_collider.png", 4.3f);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Knives/stiletto.png", 4),
                          ModAPI.LoadSprite("Skins/StilettoSkins/stiletto skin1.png", 8),
                          ModAPI.LoadSprite("Skins/StilettoSkins/stiletto skin2.png", 8),
                      };
                      Instance.FixColliders();

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.07f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Knife"),
                  NameOverride = "Survival Knife <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Quote: <<All universal is bad!>> - this also applies to survival. \n<color=purple>(3 Skins)</color>",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Knives"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/survival icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Knives/survival_collider.png", 4f);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Knives/survival.png", 3.7f),
                          ModAPI.LoadSprite("Skins/SurvivalSkins/survival skin1.png", 7.4f),
                          ModAPI.LoadSprite("Skins/SurvivalSkins/survival skin2.png", 7.4f),
                      };
                      Instance.FixColliders();

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.067f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Knife"),
                  NameOverride = "Talon <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Curved knives are also cool because you can make SCRATCHES with them! \n<color=purple>(3 Skins)</color>",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Knives"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/talon icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Knives/talon_collider.png", 4.3f);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Knives/talon.png", 4),
                          ModAPI.LoadSprite("Skins/TalonSkins/talon skin1.png", 8),
                          ModAPI.LoadSprite("Skins/TalonSkins/talon skin2.png", 8),
                      };
                      Instance.FixColliders();

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.12f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Knife"),
                  NameOverride = "Terrorist Knife <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "The manufacture of bladed weapons for the purpose of carrying out criminal activities is punishable by law. \n<color=purple>(2 Skins)</color>",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Knives"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/terror_knife icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Knives/terror_knife_collider.png", 3.9f);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Knives/terror_knife.png", 3.6f),
                          ModAPI.LoadSprite("Skins/GoldSkins/gold_terror_knife.png", 3.6f),
                      };
                      Instance.FixColliders();

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.085f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Knife"),
                  NameOverride = "Ursus Knife <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Simple as two stones. \n<color=purple>(3 Skins)</color>",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Knives"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/ursus icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Knives/ursus_collider.png", 3.7f);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Knives/ursus.png", 3.4f),
                          ModAPI.LoadSprite("Skins/UrsusSkins/ursus skin1.png", 6.8f),
                          ModAPI.LoadSprite("Skins/UrsusSkins/ursus skin2.png", 6.8f),
                      };
                      Instance.FixColliders();

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.07f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "CZ75-Auto <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Automatic but only has 12 rounds; 12 rounds, Carl! \n<color=purple>(3 Skins)</color>\n <color=yellow>Ammo: 12/12",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/auto icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/auto_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Pistols/auto_collider.png", 22);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Pistols/auto.png", 2),
                          ModAPI.LoadSprite("Skins/AutoSkins/auto skin1.png", 8),
                          ModAPI.LoadSprite("Skins/AutoSkins/auto skin2.png", 8),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/auto_reload sound.mp3");
                      Ammo.TrueMaxAmmo = 12;

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.Automatic = true;
                      firearm.AutomaticFireInterval = 0.1f;
                      firearm.barrelPosition = new Vector2(0.20f, 0.07f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/auto sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "9mm Parabellum";
                      customCartridge.Damage = 11f;
                      customCartridge.Recoil = 0.38f;
                      customCartridge.ImpactForce = 0.12f;
                      customCartridge.StartSpeed = 4f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("auto shooting", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
          						{
          							(UnityAction) (() =>
          						{

                        ModAPI.Notify("<color=orange>Switched to Auto</color>");

          							firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 11f;
          							customCartridge.Recoil = 0.38f;
          							customCartridge.ImpactForce = 0.12f;
                        customCartridge.StartSpeed = 4f;
          							firearm.Automatic = true;
          							firearm.AutomaticFireInterval = 0.1f;
                      })
                  }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 0.38f;
                        customCartridge.ImpactForce = 16f;
                        customCartridge.StartSpeed = 0.05f;
                        firearm.Automatic = true;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.08f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "Desert Eagle <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Did you know that it was made primarily for hunting? What kind of ducking crazy person would hunt with a pistol?! \n<color=purple>(4 Skins)</color>\n <color=yellow>Ammo: 7/35",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/deagle icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/deagle_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Pistols/deagle_collider.png", 22);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }

                      Instance.FixColliders();
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/deagle.png", 2);
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Pistols/deagle.png", 2),
                          ModAPI.LoadSprite("Skins/DeagleSkins/deagle skin1.png", 20),
                          ModAPI.LoadSprite("Skins/DeagleSkins/deagle skin2.png", 20),
                          ModAPI.LoadSprite("Skins/DeagleSkins/deagle skin3.png", 20),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 7;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/deagle_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.barrelPosition = new Vector2(0.24f, 0.09f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/deagle sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("50 AE");
                      customCartridge.name = ".50 Action Express";
                      customCartridge.Damage = 22.3f;
                      customCartridge.Recoil = 1.66f;
                      customCartridge.ImpactForce = 1.25f;
                      customCartridge.StartSpeed = 15f;
                      customCartridge.PenetrationRandomAngleMultiplier = 0f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 22.3f;
                        customCartridge.Recoil = 1.66f;
                        customCartridge.ImpactForce = 1.25f;
                        customCartridge.StartSpeed = 15f;
                        firearm.Automatic = false;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 1.66f;
                        customCartridge.ImpactForce = 16f;
                        customCartridge.StartSpeed = 0.05f;
                        firearm.Automatic = false;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.135f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "Dual Berettas <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Cards, money, two Berettas! Correction: for convenience, only one is used. \n<color=purple>(3 Skins)</color>\n <color=yellow>Ammo: 15/60",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/dual icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/dual_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Pistols/dual_collide.png", 24);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Pistols/dual.png", 2),
                          ModAPI.LoadSprite("Skins/DualSkins/dual skin1.png", 8),
                          ModAPI.LoadSprite("Skins/DualSkins/dual skin2.png", 8),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 15;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/dual_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.barrelPosition = new Vector2(0.17f, 0.07f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/dual sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "9mm Parabellum";
                      customCartridge.Damage = 13.6f;
                      customCartridge.Recoil = 0.4f;
                      customCartridge.ImpactForce = 0.39f;
                      customCartridge.StartSpeed = 4f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 13.6f;
                        customCartridge.Recoil = 0.4f;
                        customCartridge.ImpactForce = 0.39f;
                        customCartridge.StartSpeed = 4f;
                        firearm.Automatic = false;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 0.4f;
                        customCartridge.ImpactForce = 7.0f;
                        customCartridge.StartSpeed = 0.05f;
                        firearm.Automatic = false;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.064f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "Five-SeveN <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Accurate Five-Seven (like this description) does headshots, but is rather slow and expensive. \n<color=purple>(3 Skins).</color>\n <color=yellow>Ammo: 20/100",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/five-seven icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/five-seven_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Pistols/five_seven_collider.png", 22);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Pistols/five-seven.png", 2),
                          ModAPI.LoadSprite("Skins/Five-SevenSkins/five-seven skin1.png", 8),
                          ModAPI.LoadSprite("Skins/Five-SevenSkins/five-seven skin2.png", 8),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 20;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/five-seven_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.barrelPosition = new Vector2(0.16f, 0.07f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/five-seven sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "5,7×28mm";
                      customCartridge.Damage = 11.25f;
                      customCartridge.Recoil = 0.4f;
                      customCartridge.ImpactForce = 0.11f;
                      customCartridge.StartSpeed = 4f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 11.25f;
                        customCartridge.Recoil = 0.4f;
                        customCartridge.ImpactForce = 0.11f;
                        customCartridge.StartSpeed = 4f;
                        firearm.Automatic = false;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 0.4f;
                        customCartridge.ImpactForce = 16f;
                        customCartridge.StartSpeed = 0.05f;
                        firearm.Automatic = false;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.053f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "Glock-18 <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "I immediately answer the questions that will 100% appear: What is your favorite weapon in the game? and Why does everyone else have 3-4 skins, and the glock has 5 skins? - He is my favorite. \n<color=purple>(5 Skins)</color>\n<color=yellow>Ammo: 20/120",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/glock icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/glock_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Pistols/glock_collider.png", 22);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Pistols/glock.png", 2),
                          ModAPI.LoadSprite("Skins/GlockSkins/glock skin1.png", 8),
                          ModAPI.LoadSprite("Skins/GlockSkins/glock skin2.png", 8),
                          ModAPI.LoadSprite("Skins/GlockSkins/glock skin3.png", 8),
                          ModAPI.LoadSprite("Skins/GlockSkins/glock skin4.png", 8),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 20;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/glock_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.barrelPosition = new Vector2(0.19f, 0.06f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/glock sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "9mm Parabellum";
                      customCartridge.Damage = 10.5f;
                      customCartridge.Recoil = 0.5f;
                      customCartridge.ImpactForce = 0.7f;
                      customCartridge.StartSpeed = 4f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 10.5f;
                        customCartridge.Recoil = 0.5f;
                        customCartridge.ImpactForce = 0.7f;
                        customCartridge.StartSpeed = 4f;
          							Ammo.FireRate = 0.0001f;
          							Ammo.Auto = false;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("auto shooting", "<color=orange>Switch to Auto</color>", "<color=orange>Make it an SG with the ability to shoot bursts.\n<color=yellow>Ammo: 20/120", new UnityAction[1]
          						{
          							(UnityAction) (() =>
          						{

                        ModAPI.Notify("<color=orange>Switched to Auto</color>");

          							firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 10.5f;
          							customCartridge.Recoil = 0.5f;
          							customCartridge.ImpactForce = 0.7f;
                        customCartridge.StartSpeed = 4f;
          							Ammo.FireRate = 0.2f;
          							Ammo.Auto = true;
                      })
                  }));

                  Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                  {
                    (UnityAction) (() =>
                  {

                    ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                    ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                    firearm.BulletsPerShot = 1;
                    customCartridge.Damage = 0.0f;
                    customCartridge.Recoil = 0.5f;
                    customCartridge.ImpactForce = 16f;
                    customCartridge.StartSpeed = 0.05f;
                    Ammo.FireRate = 0.0001f;
                    Ammo.Auto = false;
                  })
                  }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.064f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "P250 <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "A gun in front of which you can not complex. Small and weak but cheap. \n<color=purple>(3 Skins)</color>\n <color=yellow>Ammo: 13/26",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/p250 icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/p250_slide.png", 2.3f);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Pistols/p250_collider.png", 25.4f);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Pistols/p250.png", 2.3f),
                          ModAPI.LoadSprite("Skins/P250Skins/p250 skin1.png", 9.2f),
                          ModAPI.LoadSprite("Skins/P250Skins/p250 skin2.png", 9.2f),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 13;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/p250_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.barrelPosition = new Vector2(0.12f, 0.10f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/p250 sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = ".357 SIG";
                      customCartridge.Damage = 13.5f;
                      customCartridge.Recoil = 0.4f;
                      customCartridge.ImpactForce = 0.4f;
                      customCartridge.StartSpeed = 4f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 13.5f;
                        customCartridge.Recoil = 0.4f;
                        customCartridge.ImpactForce = 0.4f;
                        customCartridge.StartSpeed = 4f;
                        firearm.Automatic = false;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 0.4f;
                        customCartridge.ImpactForce = 16f;
                        customCartridge.StartSpeed = 0.05f;
                        firearm.Automatic = false;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.0512f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "P2000 <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Initial pistol - initial characteristics. How can a gun with 2k in its name be relatively bad? \n<color=purple>(3 Skins)</color>\n <color=yellow>Ammo: 13/52",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/p2000 icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/p2000_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Pistols/p2000_collider.png", 22);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Pistols/p2000.png", 2),
                          ModAPI.LoadSprite("Skins/P2000Skins/p2000 skin1.png", 8),
                          ModAPI.LoadSprite("Skins/P2000Skins/p2000 skin2.png", 8),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 13;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/p2000_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.barrelPosition = new Vector2(0.14f, 0.09f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/p2000 sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = ".357 SIG2";
                      customCartridge.Damage = 12.5f;
                      customCartridge.Recoil = 0.42f;
                      customCartridge.ImpactForce = 0.67f;
                      customCartridge.StartSpeed = 4f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 12.5f;
                        customCartridge.Recoil = 0.42f;
                        customCartridge.ImpactForce = 0.67f;
                        customCartridge.StartSpeed = 4f;
                        firearm.Automatic = false;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 0.42f;
                        customCartridge.ImpactForce = 16f;
                        customCartridge.StartSpeed = 0.05f;
                        firearm.Automatic = false;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.044f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "Revolver R8 <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "A short digression on how to fit 8 rounds into a weapon, increase the damage of the deagle and feel the titanic recoil - create a revolver.... \n<color=purple>(3 Skins)</color>\n <color=yellow>Ammo: 8/8",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/r8 icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/r8_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Pistols/r8_collider.png", 27);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Pistols/r8.png", 2.5f),
                          ModAPI.LoadSprite("Skins/R8Skins/r8 skin1.png", 10),
                          ModAPI.LoadSprite("Skins/R8Skins/r8 skin2.png", 10),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 8;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/r8_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.EjectShells = false;
                      firearm.barrelPosition = new Vector2(0.31f, 0.11f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/r8 sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("50 AE");
                      customCartridge.name = ".357 Magnum";
                      customCartridge.Damage = 30.42f;
                      customCartridge.Recoil = 2.32f;
                      customCartridge.ImpactForce = 2.5f;
                      customCartridge.StartSpeed = 15f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 30.42f;
                        customCartridge.Recoil = 2.32f;
                        customCartridge.ImpactForce = 2.5f;
                        customCartridge.StartSpeed = 15f;
                        firearm.Automatic = false;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 2.32f;
                        customCartridge.ImpactForce = 16f;
                        customCartridge.StartSpeed = 0.05f;
                        firearm.Automatic = false;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.11f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "Tec-9 <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "If there was a weapon jamming mechanic in the game, this pistol would be the most disliked. \n<color=purple>(3 Skins)</color>\n <color=yellow>Ammo: 18/90",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/tec-9 icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/tec-9_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Pistols/tec-9_collider.png", 22);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Pistols/tec-9.png", 2),
                          ModAPI.LoadSprite("Skins/Tec-9Skins/tec-9 skin1.png", 8),
                          ModAPI.LoadSprite("Skins/Tec-9Skins/tec-9 skin2.png", 8),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 18;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/tec-9_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.barrelPosition = new Vector2(0.21f, 0.12f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/tec-9 sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "9mm Parabellum";
                      customCartridge.Damage = 11.8f;
                      customCartridge.Recoil = 0.38f;
                      customCartridge.ImpactForce = 0.11f;
                      customCartridge.StartSpeed = 4f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 11.8f;
                        customCartridge.Recoil = 0.38f;
                        customCartridge.ImpactForce = 0.11f;
                        customCartridge.StartSpeed = 4f;
                        firearm.Automatic = false;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 0.38f;
                        customCartridge.ImpactForce = 16f;
                        customCartridge.StartSpeed = 0.05f;
                        firearm.Automatic = false;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.092f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "USP <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "German weapons - German quality - German hunting! \n<color=purple>(2 Skins)</color>\n <color=yellow>Ammo: 12/24",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/usp-s icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/usp-s_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Pistols/usp-s_collider.png", 24);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Pistols/usp-s.png", 2),
                          ModAPI.LoadSprite("Skins/USP-SSkins/usp-s skin1.png", 8),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 12;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/usp_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.barrelPosition = new Vector2(0.15f, 0.06f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/usp-s sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = ".45 ACP";
                      customCartridge.Damage = 12.5f;
                      customCartridge.Recoil = 0.4f;
                      customCartridge.ImpactForce = 0.67f;
                      customCartridge.StartSpeed = 4f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 12.5f;
                        customCartridge.Recoil = 0.4f;
                        customCartridge.ImpactForce = 0.67f;
                        customCartridge.StartSpeed = 4f;
                        firearm.Automatic = false;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 0.4f;
                        customCartridge.ImpactForce = 16f;
                        customCartridge.StartSpeed = 0.05f;
                        firearm.Automatic = false;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.056f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "USP-S <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Silence! I play USP-S with auto-aim. Don't call me! \n<color=purple>(2 Skins)</color>\n <color=yellow>Ammo: 12/24",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/usp-s_silence icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/usp-s_silence_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Pistols/usp-s_silence_collider.png", 23);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Pistols/usp-s_silence.png", 2),
                          ModAPI.LoadSprite("Skins/USP-S_SilentSkins/usp-s_silent skin1.png", 8),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 12;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/usp_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.barrelPosition = new Vector2(0.38f, 0.06f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/usp-s_silence sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = ".45 ACP";
                      customCartridge.Damage = 12.5f;
                      customCartridge.Recoil = 0.4f;
                      customCartridge.ImpactForce = 0.67f;
                      customCartridge.StartSpeed = 4f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 12.5f;
                        customCartridge.Recoil = 0.4f;
                        customCartridge.ImpactForce = 0.67f;
                        customCartridge.StartSpeed = 4f;
                        firearm.Automatic = false;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 0.4f;
                        customCartridge.ImpactForce = 16f;
                        customCartridge.StartSpeed = 0.05f;
                        firearm.Automatic = false;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.063f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Shotgun"),
                  NameOverride = "MAG-7 <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "My mother: Africa. My dad: UZI. \n<color=purple>(3 Skins)</color>\n <color=yellow>Ammo: 5/32",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/mag-7 icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var ShotgunSlide = Instance.transform.Find("Slide");
                      ShotgunSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Shotguns/mag-7_slide.png", 2);
                      ShotgunSlide.GetComponent<SpriteRenderer>().color = Color.white;
                      ShotgunSlide.localScale = new Vector3(1f, 1f);
                      var ShotgunCover = Instance.transform.Find("Cover");
                      ShotgunCover.gameObject.AddComponent<PhysicalBehaviour>().Disintegrate();

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Shotguns/mag-7_collider.png", 22);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Shotguns/mag-7.png", 2),
                          ModAPI.LoadSprite("Skins/MAG-7Skins/mag-7 skin1.png", 8),
                          ModAPI.LoadSprite("Skins/MAG-7Skins/mag-7 skin2.png", 8),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 5;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/mag-7_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 5;
                      firearm.barrelPosition = new Vector2(0.31f, 0.11f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/mag-7 sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "12";
                      customCartridge.Damage = 24.5f;
                      customCartridge.Recoil = 0.25f;
                      customCartridge.ImpactForce = 0.22f;
                      customCartridge.StartSpeed = 8f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 5;
                        customCartridge.Damage = 24.5f;
                        customCartridge.Recoil = 0.25f;
                        customCartridge.ImpactForce = 0.22f;
                        customCartridge.StartSpeed = 8f;
                        Ammo.FireRate = 0.0001f;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("cooldown", "<color=#3D81FF>Cooldown Mode</color>", "<color=#3D81FF>Makes the weapon cooldown. (if you want more realism)</color>\n Cooldown: 0.65s", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=#3D81FF>Switched Cooldown</color>");

                        firearm.BulletsPerShot = 5;
                        customCartridge.Damage = 24.5f;
                        customCartridge.Recoil = 0.25f;
                        customCartridge.ImpactForce = 0.22f;
                        customCartridge.StartSpeed = 8f;
                        Ammo.FireRate = 0.65f;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 2.32f;
                        customCartridge.ImpactForce = 16.0f;
                        customCartridge.StartSpeed = 0.05f;
                        Ammo.FireRate = 0.0001f;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.15f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Shotgun"),
                  NameOverride = "Nova <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Opening of the Duck Hunting Season! \n<color=purple>(3 Skins)</color>\n <color=yellow>Ammo: 8/32",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/nova icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var ShotgunSlide = Instance.transform.Find("Slide");
                      ShotgunSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Shotguns/nova_slide.png", 1.5f);
                      ShotgunSlide.GetComponent<SpriteRenderer>().color = Color.white;
                      ShotgunSlide.localScale = new Vector3(1f, 1f);
                      var ShotgunCover = Instance.transform.Find("Cover");
                      ShotgunCover.gameObject.AddComponent<PhysicalBehaviour>().Disintegrate();

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Shotguns/nova_collider.png", 16.5f);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Shotguns/nova.png", 1.5f),
                          ModAPI.LoadSprite("Skins/NovaSkins/nova skin1.png", 6),
                          ModAPI.LoadSprite("Skins/NovaSkins/nova skin2.png", 6),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 8;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/nova_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 5;
                      firearm.barrelPosition = new Vector2(0.71f, 0.12f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/nova sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "12";
                      customCartridge.Damage = 21f;
                      customCartridge.Recoil = 0.25f;
                      customCartridge.ImpactForce = 0.26f;
                      customCartridge.StartSpeed = 8f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 5;
                        customCartridge.Damage = 21f;
                        customCartridge.Recoil = 0.25f;
                        customCartridge.ImpactForce = 0.26f;
                        customCartridge.StartSpeed = 8f;
                        Ammo.FireRate = 0.0001f;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("cooldown", "<color=#3D81FF>Cooldown Mode</color>", "<color=#3D81FF>Makes the weapon cooldown. (if you want more realism)</color>\n Cooldown: 0.68s", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=#3D81FF>Switched Cooldown</color>");

                        firearm.BulletsPerShot = 5;
                        customCartridge.Damage = 21f;
                        customCartridge.Recoil = 0.25f;
                        customCartridge.ImpactForce = 0.26f;
                        customCartridge.StartSpeed = 8f;
                        Ammo.FireRate = 0.68f;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 0.38f;
                        customCartridge.ImpactForce = 7.0f;
                        customCartridge.StartSpeed = 0.05f;
                        Ammo.FireRate = 0.0001f;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.09f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Shotgun"),
                  NameOverride = "Sawed-Off <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Yes, oblique, yes, short-sighted, but light! ... by 100 grams. \n<color=purple>(3 Skins)</color>\n <color=yellow>Ammo: 7/32",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/sawed-off icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var ShotgunSlide = Instance.transform.Find("Slide");
                      ShotgunSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Shotguns/sawed-off_slide.png", 2);
                      ShotgunSlide.GetComponent<SpriteRenderer>().color = Color.white;
                      ShotgunSlide.localScale = new Vector3(1f, 1f);
                      var ShotgunCover = Instance.transform.Find("Cover");
                      ShotgunCover.gameObject.AddComponent<PhysicalBehaviour>().Disintegrate();

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Shotguns/sawed-off_collider.png", 22);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Shotguns/sawed-off.png", 2),
                          ModAPI.LoadSprite("Skins/Sawed-OffSkins/sawed-off skin1.png", 8),
                          ModAPI.LoadSprite("Skins/Sawed-OffSkins/sawed-off skin2.png", 8),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 7;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/sawed-off_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 5;
                      firearm.barrelPosition = new Vector2(0.56f, 0.12f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/sawed-off sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "12";
                      customCartridge.Damage = 25.6f;
                      customCartridge.Recoil = 0.253f;
                      customCartridge.ImpactForce = 0.35f;
                      customCartridge.StartSpeed = 8f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 5;
                        customCartridge.Damage = 25.6f;
                        customCartridge.Recoil = 0.253f;
                        customCartridge.ImpactForce = 0.55f;
                        customCartridge.StartSpeed = 8f;
                        Ammo.FireRate = 0.0001f;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("cooldown", "<color=#3D81FF>Cooldown Mode</color>", "<color=#3D81FF>Makes the weapon cooldown. (if you want more realism)</color>\n Cooldown: 0.65s", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=#3D81FF>Switched Cooldown</color>");

                        firearm.BulletsPerShot = 5;
                        customCartridge.Damage = 25.6f;
                        customCartridge.Recoil = 0.253f;
                        customCartridge.ImpactForce = 0.55f;
                        customCartridge.StartSpeed = 8f;
                        Ammo.FireRate = 0.65f;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 0.4f;
                        customCartridge.ImpactForce = 7.0f;
                        customCartridge.StartSpeed = 0.05f;
                        Ammo.FireRate = 0.0001f;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.06f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Shotgun"),
                  NameOverride = "XM1014 <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "That same feeling when you were sold a shotgun exactly like everyone else, but worth twice as much (T_T) \n<color=purple>(3 Skins)</color>\n <color=yellow>Ammo: 7/32",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/xm1014 icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var ShotgunSlide = Instance.transform.Find("Slide");
                      ShotgunSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/xm1014_slide.png", 2);
                      var ShotgunCover = Instance.transform.Find("Cover");
                      ShotgunCover.gameObject.AddComponent<PhysicalBehaviour>().Disintegrate();

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Shotguns/xm1014_collider.png", 16.5f);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Shotguns/xm1014.png", 1.5f),
                          ModAPI.LoadSprite("Skins/XM1014Skins/xm1014 skin1.png", 6),
                          ModAPI.LoadSprite("Skins/XM1014Skins/xm1014 skin2.png", 6),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 7;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/xm1014_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 5;
                      firearm.barrelPosition = new Vector2(0.825f, 0.13f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/xm1014 sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "12";
                      customCartridge.Damage = 16.5f;
                      customCartridge.Recoil = 0.25f;
                      customCartridge.ImpactForce = 0.2f;
                      customCartridge.StartSpeed = 8f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 5;
                        customCartridge.Damage = 16.5f;
                        customCartridge.Recoil = 0.25f;
                        customCartridge.ImpactForce = 0.2f;
                        customCartridge.StartSpeed = 8f;
                        Ammo.FireRate = 0.0001f;
                        Ammo.Auto = false;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("cooldown", "<color=#3D81FF>Cooldown Mode</color>", "<color=#3D81FF>Makes the weapon cooldown. (if you want more realism)</color>\n Cooldown: 0.8s", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=#3D81FF>Switched Cooldown</color>");

                        firearm.BulletsPerShot = 5;
                        customCartridge.Damage = 16.5f;
                        customCartridge.Recoil = 0.25f;
                        customCartridge.ImpactForce = 0.2f;
                        customCartridge.StartSpeed = 8f;
                        Ammo.FireRate = 0.8f;
          							Ammo.Auto = false;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("auto shooting", "<color=orange>Switch to Auto</color>", "<color=orange>Make it an SG with the ability to shoot bursts.\n<color=yellow>Ammo: 7/32", new UnityAction[1]
          						{
          							(UnityAction) (() =>
          						{

                        ModAPI.Notify("<color=orange>Switched to Auto</color>");

          							firearm.BulletsPerShot = 5;
                        customCartridge.Damage = 16.5f;
                        customCartridge.Recoil = 0.25f;
                        customCartridge.ImpactForce = 0.2f;
                        customCartridge.StartSpeed = 8f;
                        Ammo.FireRate = 1f;
          							Ammo.Auto = true;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 0.4f;
                        customCartridge.ImpactForce = 7.0f;
                        customCartridge.StartSpeed = 0.05f;
                        Ammo.FireRate = 0.0001f;
          							Ammo.Auto = false;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "PP-Bizon <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "In real life: his magazine costs several times more than the weapon itself. In the game: I will change it after each shot! \n<color=purple>(4 Skins)</color>\n <color=yellow>Ammo: 64/120",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/bizon icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Subguns/bizon_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Subguns/bizon_collider.png", 22f);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Subguns/bizon.png", 2),
                          ModAPI.LoadSprite("Skins/BizonSkins/bizon skin1.png", 8),
                          ModAPI.LoadSprite("Skins/BizonSkins/bizon skin2.png", 8),
                          ModAPI.LoadSprite("Skins/BizonSkins/bizon skin3.png", 8),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 64;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/bizon_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.Automatic = true;
                      firearm.AutomaticFireInterval = 0.08f;
                      firearm.barrelPosition = new Vector2(0.51f, 0.11f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/bizon sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "9mm Parabellum";
                      customCartridge.Damage = 9.6f;
                      customCartridge.Recoil = 0.525f;
                      customCartridge.ImpactForce = 0.13f;
                      customCartridge.StartSpeed = 4f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("auto shooting", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 9.6f;
                        customCartridge.Recoil = 0.525f;
                        customCartridge.ImpactForce = 0.13f;
                        customCartridge.StartSpeed = 4f;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 0.4f;
                        customCartridge.ImpactForce = 7.0f;
                        customCartridge.StartSpeed = 0.05f;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.135f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "MAC-10 <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Once a year, even a simple box shoots. \n<color=purple>(3 Skins)</color>\n <color=yellow>Ammo: 30/120",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/uzi icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Subguns/uzi_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Subguns/uzi_collider.png", 22);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Subguns/uzi.png", 2),
                          ModAPI.LoadSprite("Skins/UziSkins/uzi skin1.png", 8),
                          ModAPI.LoadSprite("Skins/UziSkins/uzi skin2.png", 8),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 30;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/uzi_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.Automatic = true;
                      firearm.AutomaticFireInterval = 0.075f;
                      firearm.barrelPosition = new Vector2(0.11f, 0.07f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/mac-10 sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = ".45 ACP";
                      customCartridge.Damage = 10.2f;
                      customCartridge.Recoil = 0.54f;
                      customCartridge.ImpactForce = 0.16f;
                      customCartridge.StartSpeed = 4f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("auto shooting", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 10.2f;
                        customCartridge.Recoil = 0.54f;
                        customCartridge.ImpactForce = 0.16f;
                        customCartridge.StartSpeed = 4f;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 0.4f;
                        customCartridge.ImpactForce = 7.0f;
                        customCartridge.StartSpeed = 0.05f;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.08f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "MP5-SD <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Even in CoD1 it was possible to switch the fire, but not here! though no one has used it... \n<color=purple>(3 Skins)</color>\n <color=yellow>Ammo: 30/120",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/mp5-sd icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Subguns/mp5-sd_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Subguns/mp5-sd_collider.png", 22);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Subguns/mp5-sd.png", 2),
                          ModAPI.LoadSprite("Skins/MP5-SDSkins/mp5-sd skin1.png", 8),
                          ModAPI.LoadSprite("Skins/MP5-SDSkins/mp5-sd skin2.png", 8),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 30;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/mp5-sd_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.Automatic = true;
                      firearm.AutomaticFireInterval = 0.075f;
                      firearm.barrelPosition = new Vector2(0.81f, 0.14f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/mp5-sd sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "9mm Parabellum";
                      customCartridge.Damage = 9.55f;
                      customCartridge.Recoil = 0.5f;
                      customCartridge.ImpactForce = 0.137f;
                      customCartridge.StartSpeed = 4f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("auto shooting", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 9.55f;
                        customCartridge.Recoil = 0.5f;
                        customCartridge.ImpactForce = 0.137f;
                        customCartridge.StartSpeed = 4f;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 0.4f;
                        customCartridge.ImpactForce = 7.0f;
                        customCartridge.StartSpeed = 0.05f;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.175f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "MP7 <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Uzi new generation. \n<color=purple>(3 Skins)</color>\n <color=yellow>Ammo: 30/120",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/mp7 icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Subguns/mp7_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Subguns/mp7_collider.png", 22);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Subguns/mp7.png", 2),
                          ModAPI.LoadSprite("Skins/MP7Skins/mp7 skin1.png", 8),
                          ModAPI.LoadSprite("Skins/MP7Skins/mp7 skin2.png", 8),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 30;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/mp7_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.Automatic = true;
                      firearm.AutomaticFireInterval = 0.075f;
                      firearm.barrelPosition = new Vector2(0.26f, 0.11f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/mp7 sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "9mm Parabellum";
                      customCartridge.Damage = 9.8f;
                      customCartridge.Recoil = 0.5f;
                      customCartridge.ImpactForce = 0.137f;
                      customCartridge.StartSpeed = 4f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("auto shooting", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 9.8f;
                        customCartridge.Recoil = 0.5f;
                        customCartridge.ImpactForce = 0.137f;
                        customCartridge.StartSpeed = 4f;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 0.4f;
                        customCartridge.ImpactForce = 7.0f;
                        customCartridge.StartSpeed = 0.05f;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "MP9 <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Don't mess with Swiss! First their knife now this. \n<color=purple>(3 Skins)</color>\n <color=yellow>Ammo: 30/120",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/mp9 icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Subguns/mp9_slide.png", 2.5f);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Subguns/mp9_collider.png", 27.5f);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Subguns/mp9.png", 2.5f),
                          ModAPI.LoadSprite("Skins/MP9Skins/mp9 skin1.png", 10),
                          ModAPI.LoadSprite("Skins/MP9Skins/mp9 skin2.png", 10),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 30;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/mp9_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.Automatic = true;
                      firearm.AutomaticFireInterval = 0.07f;
                      firearm.barrelPosition = new Vector2(0.27f, 0.14f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/mp9 sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "9mm Parabellum";
                      customCartridge.Damage = 9.3f;
                      customCartridge.Recoil = 0.525f;
                      customCartridge.ImpactForce = 0.145f;
                      customCartridge.StartSpeed = 4f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("auto shooting", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 9.3f;
                        customCartridge.Recoil = 0.525f;
                        customCartridge.ImpactForce = 0.145f;
                        customCartridge.StartSpeed = 4f;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 0.4f;
                        customCartridge.ImpactForce = 7.0f;
                        customCartridge.StartSpeed = 0.05f;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.09f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "P90 <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "The only submachine gun to understand the location of the trigger, bolt, store you need to google. \n<color=purple>(3 Skins)</color>\n <color=yellow>Ammo: 50/100",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/p90 icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Subguns/p90_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Subguns/p90_collider.png", 22);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Subguns/p90.png", 2),
                          ModAPI.LoadSprite("Skins/P90Skins/p90 skin1.png", 8),
                          ModAPI.LoadSprite("Skins/P90Skins/p90 skin2.png", 8),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 50;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/p90_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.Automatic = true;
                      firearm.AutomaticFireInterval = 0.07f;
                      firearm.barrelPosition = new Vector2(0.24f, 0.11f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/p90 sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "5,7×28mm";
                      customCartridge.Damage = 9.2f;
                      customCartridge.Recoil = 0.4f;
                      customCartridge.ImpactForce = 0.12f;
                      customCartridge.StartSpeed = 4f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("auto shooting", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 9.2f;
                        customCartridge.Recoil = 0.4f;
                        customCartridge.ImpactForce = 0.12f;
                        customCartridge.StartSpeed = 4f;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 0.4f;
                        customCartridge.ImpactForce = 7.0f;
                        customCartridge.StartSpeed = 0.05f;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.135f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "UMP-45 <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "I wonder only the Germans know how to make normal submachine guns? \n<color=purple>(4 Skins)</color>\n <color=yellow>Ammo: 25/100",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/ump-45 icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Subguns/ump-45_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Subguns/ump-45_collider.png", 22);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Subguns/ump-45.png", 2),
                          ModAPI.LoadSprite("Skins/UMP-45Skins/ump-45 skin1.png", 8),
                          ModAPI.LoadSprite("Skins/UMP-45Skins/ump-45 skin2.png", 8),
                          ModAPI.LoadSprite("Skins/UMP-45Skins/ump-45 skin3.png", 8),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 25;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/ump-45_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.Automatic = true;
                      firearm.AutomaticFireInterval = 0.09666f;
                      firearm.barrelPosition = new Vector2(0.46f, 0.11f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/ump-45 sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = ".45 АСР";
                      customCartridge.Damage = 12.5f;
                      customCartridge.Recoil = 0.575f;
                      customCartridge.ImpactForce = 0.13f;
                      customCartridge.StartSpeed = 4f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("auto shooting", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 12.5f;
                        customCartridge.Recoil = 0.575f;
                        customCartridge.ImpactForce = 0.13f;
                        customCartridge.StartSpeed = 4f;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 0.4f;
                        customCartridge.ImpactForce = 7.0f;
                        customCartridge.StartSpeed = 0.05f;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.135f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                  NameOverride = "AWP <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "One shot = 10 kills. \n<color=purple>(4 Skins)</color>\n <color=yellow>Ammo: 10/30",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/awp icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                    var Weapon = Instance.transform;
                    var Cover = new GameObject("Cover");
                    Cover.transform.SetParent(Weapon);
                    Cover.transform.localPosition = new Vector3(0f, 0f);
                    Cover.transform.rotation = Weapon.rotation;
                    Cover.transform.localScale = new Vector3(1f, 1f);
                    var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                    CoverSprite.sprite = ModAPI.LoadSprite("Sniper Rifles/awp_cover.png", 2);
                    CoverSprite.sortingOrder = 7;

                      ModAPI.KeepExtraObjects();

                      var RifleSlide = Instance.transform.Find("Slide");
                      RifleSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sniper Rifles/awp_slide.png", 2);
                      RifleSlide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Sniper Rifles/awp_collider.png", 22);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Sniper Rifles/awp.png", 2),
                          ModAPI.LoadSprite("Skins/AWPSkins/awp skin1.png", 20),
                          ModAPI.LoadSprite("Skins/AWPSkins/awp skin2.png", 8),
                          ModAPI.LoadSprite("Skins/AWPSkins/awp skin3.png", 8),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 10;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/awp_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.Automatic = false;
                      firearm.barrelPosition = new Vector2(1.19f, 0.15f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/awp sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = ".308 Winchester";
                      customCartridge.Damage = 200f;
                      customCartridge.Recoil = 1.575f;
                      customCartridge.ImpactForce = 3f;
                      customCartridge.StartSpeed = 100f;
                      customCartridge.PenetrationRandomAngleMultiplier = 0f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-Auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 200f;
                        customCartridge.Recoil = 1.575f;
                        customCartridge.ImpactForce = 3f;
                        customCartridge.StartSpeed = 100f;
                        Ammo.FireRate = 0.0001f;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("cooldown", "<color=#3D81FF>Cooldown Mode</color>", "<color=#3D81FF>Makes the weapon cooldown. (if you want more realism)</color>\n Cooldown: 1.11s", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=#3D81FF>Switched Cooldown</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 200f;
                        customCartridge.Recoil = 1.575f;
                        customCartridge.ImpactForce = 3f;
                        customCartridge.StartSpeed = 100f;
                        Ammo.FireRate = 1.11f;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 0.4f;
                        customCartridge.ImpactForce = 16f;
                        customCartridge.StartSpeed = 0.05f;
                        Ammo.FireRate = 0.0001f;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.17f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                  NameOverride = "G3SG1 <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Is that fair? - Of course, I am talking about the capture of the arms market by the Germans. \n<color=purple>(3 Skins)</color>\n <color=yellow>Ammo: 20/90",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/g3sg1 icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var RifleSlide = Instance.transform.Find("Slide");
                      RifleSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sniper Rifles/g3sg1_slide.png", 2);
                      RifleSlide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Sniper Rifles/g3sg1_collider.png", 22);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Sniper Rifles/g3sg1.png", 2),
                          ModAPI.LoadSprite("Skins/G3SG1Skins/g3sg1 skin1.png", 8),
                          ModAPI.LoadSprite("Skins/G3SG1Skins/g3sg1 skin2.png", 8),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 20;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/g3sg1_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.Automatic = true;
                      firearm.AutomaticFireInterval = 0.25f;
                      firearm.barrelPosition = new Vector2(0.86f, 0.125f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/g3sg1 sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "7,62×51mm NATO";
                      customCartridge.Damage = 20f;
                      customCartridge.Recoil = 0.74f;
                      customCartridge.ImpactForce = 0.17f;
                      customCartridge.StartSpeed = 22f;
                      customCartridge.PenetrationRandomAngleMultiplier = 0f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("auto shooting", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 20f;
                        customCartridge.Recoil = 0.74f;
                        customCartridge.ImpactForce = 0.17f;
                        customCartridge.StartSpeed = 22f;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 0.4f;
                        customCartridge.ImpactForce = 16f;
                        customCartridge.StartSpeed = 0.05f;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                  NameOverride = "SCAR-20 <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "How to identify the SCAR series: 1. Khaki color; 2. Application of tactical straps wherever possible; 3. And the inscriptions on the weapons ... ah .... \n<color=purple>(3 Skins)</color>\n <color=yellow>Ammo: 20/90",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/scar-20 icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var RifleSlide = Instance.transform.Find("Slide");
                      RifleSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sniper Rifles/scar-20_slide.png", 2);
                      RifleSlide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Sniper Rifles/scar-20_collider.png", 22);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Sniper Rifles/scar-20.png", 2),
                          ModAPI.LoadSprite("Skins/SCAR-20Skins/scar-20 skin1.png", 8),
                          ModAPI.LoadSprite("Skins/SCAR-20Skins/scar-20 skin2.png", 8),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 20;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/scar-20_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.Automatic = true;
                      firearm.AutomaticFireInterval = 0.25f;
                      firearm.barrelPosition = new Vector2(0.91f, 0.14f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/scar-20 sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "7,62×51mm NATO";
                      customCartridge.Damage = 20f;
                      customCartridge.Recoil = 0.635f;
                      customCartridge.ImpactForce = 0.17f;
                      customCartridge.StartSpeed = 22f;
                      customCartridge.PenetrationRandomAngleMultiplier = 0f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("auto shooting", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 20f;
                        customCartridge.Recoil = 0.635f;
                        customCartridge.ImpactForce = 0.17f;
                        customCartridge.StartSpeed = 22f;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 0.4f;
                        customCartridge.ImpactForce = 16f;
                        customCartridge.StartSpeed = 0.05f;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.087f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                  NameOverride = "SSG 08 <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Time to feel like a real sniper. \n<color=purple>(3 Skins)</color>\n <color=yellow>Ammo: 10/90",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/ssg08 icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                    var Weapon = Instance.transform;
                    var Cover = new GameObject("Cover");
                    Cover.transform.SetParent(Weapon);
                    Cover.transform.localPosition = new Vector3(0f, 0f);
                    Cover.transform.rotation = Weapon.rotation;
                    Cover.transform.localScale = new Vector3(1f, 1f);
                    var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                    CoverSprite.sprite = ModAPI.LoadSprite("Sniper Rifles/ssg08_cover.png", 2);
                    CoverSprite.sortingOrder = 7;

                      ModAPI.KeepExtraObjects();

                      var RifleSlide = Instance.transform.Find("Slide");
                      RifleSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sniper Rifles/ssg08_slide.png", 2);
                      RifleSlide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Sniper Rifles/ssg08_collider.png", 22);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Sniper Rifles/ssg08.png", 2),
                          ModAPI.LoadSprite("Skins/SSG 08Skins/ssg08 skin1.png", 8),
                          ModAPI.LoadSprite("Skins/SSG 08Skins/ssg08 skin2.png", 8),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 10;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/ssg08_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.Automatic = false;
                      firearm.barrelPosition = new Vector2(1.21f, 0.18f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/ssg08 sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "7,62×51mm NATO";
                      customCartridge.Damage = 67.5f;
                      customCartridge.Recoil = 0.950f;
                      customCartridge.ImpactForce = 2.55f;
                      customCartridge.StartSpeed = 30f;
                      customCartridge.PenetrationRandomAngleMultiplier = 0f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-Auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 67.5f;
                        customCartridge.Recoil = 0.950f;
                        customCartridge.ImpactForce = 2.55f;
                        customCartridge.StartSpeed = 30f;
                        Ammo.FireRate = 0.0001f;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("cooldown", "<color=#3D81FF>Cooldown Mode</color>", "<color=#3D81FF>Makes the weapon cooldown. (if you want more realism)</color>\n Cooldown: 1.16s", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=#3D81FF>Switched Cooldown</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 67.5f;
                        customCartridge.Recoil = 0.950f;
                        customCartridge.ImpactForce = 2.55f;
                        customCartridge.StartSpeed = 30f;
                        Ammo.FireRate = 1.16f;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 0.4f;
                        customCartridge.ImpactForce = 16f;
                        customCartridge.StartSpeed = 0.05f;
                        Ammo.FireRate = 0.0001f;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.133f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                  NameOverride = "AK-47 <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Approved by Stalin. \n<color=purple>(4 Skins)</color>\n <color=yellow>Ammo: 30/90",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/ak-47 icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var RifleSlide = Instance.transform.Find("Slide");
                      RifleSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Rifles/ak-47_slide.png", 2);
                      RifleSlide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Rifles/ak-47_collider.png", 22);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Rifles/ak-47.png", 2),
                          ModAPI.LoadSprite("Skins/AK-47Skins/ak-47 skin1.png", 16),
                          ModAPI.LoadSprite("Skins/AK-47Skins/ak-47 skin2.png", 8),
                          ModAPI.LoadSprite("Skins/AK-47Skins/ak-47 skin3.png", 8),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 30;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/ak-47_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.Automatic = true;
                      firearm.AutomaticFireInterval = 0.1f;
                      firearm.barrelPosition = new Vector2(0.52f, 0.11f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/ak-47 sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "7,62×39mm";
                      customCartridge.Damage = 16.2f;
                      customCartridge.Recoil = 0.71f;
                      customCartridge.ImpactForce = 0.055f;
                      customCartridge.StartSpeed = 12f;
                      customCartridge.PenetrationRandomAngleMultiplier = 0f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("auto shooting", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 16.2f;
                        customCartridge.Recoil = 0.71f;
                        customCartridge.ImpactForce = 0.055f;
                        customCartridge.StartSpeed = 12f;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 0.4f;
                        customCartridge.ImpactForce = 16f;
                        customCartridge.StartSpeed = 0.05f;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.083f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                  NameOverride = "AUG <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "This is a bull-pup and... WE hate it! Why? - WE can it! \n<color=purple>(4 Skins)</color>\n <color=yellow>Ammo: 30/90",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/aug icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var RifleSlide = Instance.transform.Find("Slide");
                      RifleSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Rifles/aug_slide.png", 2);
                      RifleSlide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Rifles/aug_collider.png", 22);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Rifles/aug.png", 2),
                          ModAPI.LoadSprite("Skins/AUGSkins/aug skin1.png", 8),
                          ModAPI.LoadSprite("Skins/AUGSkins/aug skin2.png", 8),
                          ModAPI.LoadSprite("Skins/AUGSkins/aug skin3.png", 8),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 30;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/aug_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.Automatic = true;
                      firearm.AutomaticFireInterval = 0.1f;
                      firearm.barrelPosition = new Vector2(0.41f, 0.14f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/aug sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "5,56×45mm NATO";
                      customCartridge.Damage = 13.8f;
                      customCartridge.Recoil = 0.675f;
                      customCartridge.ImpactForce = 0.042f;
                      customCartridge.StartSpeed = 12f;
                      customCartridge.PenetrationRandomAngleMultiplier = 0f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("auto shooting", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 13.8f;
                        customCartridge.Recoil = 0.675f;
                        customCartridge.ImpactForce = 0.042f;
                        customCartridge.StartSpeed = 12f;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 0.4f;
                        customCartridge.ImpactForce = 16f;
                        customCartridge.StartSpeed = 0.05f;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.083f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                  NameOverride = "Famas <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "French view to assault rifles and a war in general. \n<color=purple>(3 Skins)</color>\n <color=yellow>Ammo: 25/90",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/famas icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var RifleSlide = Instance.transform.Find("Slide");
                      RifleSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Rifles/famas_slide.png", 2);
                      RifleSlide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Rifles/famas_collider.png", 22);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Rifles/famas.png", 2),
                          ModAPI.LoadSprite("Skins/FamasSkins/famas skin1.png", 8),
                          ModAPI.LoadSprite("Skins/FamasSkins/famas skin2.png", 8),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 25;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/famas_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.Automatic = true;
                      firearm.AutomaticFireInterval = 0.09f;
                      firearm.barrelPosition = new Vector2(0.26f, 0.08f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/famas sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "5,56×45mm NATO";
                      customCartridge.Damage = 14.5f;
                      customCartridge.Recoil = 0.65f;
                      customCartridge.ImpactForce = 0.06f;
                      customCartridge.StartSpeed = 12f;
                      customCartridge.PenetrationRandomAngleMultiplier = 0f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("auto shooting", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 14.5f;
                        customCartridge.Recoil = 0.65f;
                        customCartridge.ImpactForce = 0.06f;
                        customCartridge.StartSpeed = 12f;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 0.4f;
                        customCartridge.ImpactForce = 16f;
                        customCartridge.StartSpeed = 0.05f;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.084f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                  NameOverride = "Galil AR <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Kosher assault rifle. \n<color=purple>(3 Skins)</color>\n <color=yellow>Ammo: 35/90",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/galil icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var RifleSlide = Instance.transform.Find("Slide");
                      RifleSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Rifles/galil_slide.png", 2);
                      RifleSlide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Rifles/galil_collider.png", 22);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Rifles/galil.png", 2),
                          ModAPI.LoadSprite("Skins/GalilSkins/galil skin1.png", 8),
                          ModAPI.LoadSprite("Skins/GalilSkins/galil skin2.png", 8),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 35;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/galil_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.Automatic = true;
                      firearm.AutomaticFireInterval = 0.09f;
                      firearm.barrelPosition = new Vector2(0.44f, 0.10f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/galil sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "5,56×45mm NATO";
                      customCartridge.Damage = 14.5f;
                      customCartridge.Recoil = 0.71f;
                      customCartridge.ImpactForce = 0.055f;
                      customCartridge.StartSpeed = 12f;
                      customCartridge.PenetrationRandomAngleMultiplier = 0f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("auto shooting", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 14.5f;
                        customCartridge.Recoil = 0.71f;
                        customCartridge.ImpactForce = 0.055f;
                        customCartridge.StartSpeed = 12f;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 0.4f;
                        customCartridge.ImpactForce = 16f;
                        customCartridge.StartSpeed = 0.05f;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.09f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                  NameOverride = "M4A1 <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "There are the Vietnamese flashbacks. \n<color=purple>(3 Skins)</color>\n <color=yellow>Ammo: 20/80",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/m4a1 icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var RifleSlide = Instance.transform.Find("Slide");
                      RifleSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Rifles/m4a1_slide.png", 2);
                      RifleSlide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Rifles/m4a1_collider.png", 22);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Rifles/m4a1.png", 2),
                          ModAPI.LoadSprite("Skins/M4A1Skins/m4a1 skin1.png", 8),
                          ModAPI.LoadSprite("Skins/M4A1Skins/m4a1 skin2.png", 8),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 20;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/m4a4_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.Automatic = true;
                      firearm.AutomaticFireInterval = 0.1f;
                      firearm.barrelPosition = new Vector2(0.52f, 0.12f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/m4a1 sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "5,56×45mm NATO";
                      customCartridge.Damage = 15.5f;
                      customCartridge.Recoil = 0.69f;
                      customCartridge.ImpactForce = 0.06f;
                      customCartridge.StartSpeed = 12f;
                      customCartridge.PenetrationRandomAngleMultiplier = 0f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("auto shooting", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 15.5f;
                        customCartridge.Recoil = 0.69f;
                        customCartridge.ImpactForce = 0.06f;
                        customCartridge.StartSpeed = 12f;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 0.4f;
                        customCartridge.ImpactForce = 16f;
                        customCartridge.StartSpeed = 0.05f;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.0625f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                  NameOverride = "M4A1-S <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "They are on trees, Johnny!  \n<color=purple>(3 Skins)</color>\n <color=yellow>Ammo: 20/80",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/m4a1-s icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var RifleSlide = Instance.transform.Find("Slide");
                      RifleSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Rifles/m4a1_slide.png", 2);
                      RifleSlide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Rifles/m4a1-s_collider.png", 22);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Rifles/m4a1-s.png", 2),
                          ModAPI.LoadSprite("Skins/M4A1-SSkins/m4a1-s skin1.png", 8),
                          ModAPI.LoadSprite("Skins/M4A1-SSkins/m4a1-s skin2.png", 8),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 20;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/m4a4_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.Automatic = true;
                      firearm.AutomaticFireInterval = 0.1f;
                      firearm.barrelPosition = new Vector2(0.75f, 0.12f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/m4a1-s sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "5,56×45mm NATO";
                      customCartridge.Damage = 15.5f;
                      customCartridge.Recoil = 0.69f;
                      customCartridge.ImpactForce = 0.06f;
                      customCartridge.StartSpeed = 12f;
                      customCartridge.PenetrationRandomAngleMultiplier = 0f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("auto shooting", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 15.5f;
                        customCartridge.Recoil = 0.69f;
                        customCartridge.ImpactForce = 0.06f;
                        customCartridge.StartSpeed = 12f;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 0.4f;
                        customCartridge.ImpactForce = 16f;
                        customCartridge.StartSpeed = 0.05f;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.0635f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                  NameOverride = "M4A4 <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Democracy never finds easy ways. \n<color=purple>(3 Skins)</color>\n <color=yellow>Ammo: 30/90",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/m4a4 icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var RifleSlide = Instance.transform.Find("Slide");
                      RifleSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Rifles/m4a4_slide.png", 2);
                      RifleSlide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Rifles/m4a4_collider.png", 22);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Rifles/m4a4.png", 2),
                          ModAPI.LoadSprite("Skins/M4A4Skins/m4a4 skin1.png", 8),
                          ModAPI.LoadSprite("Skins/M4A4Skins/m4a4 skin2.png", 8),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 30;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/m4a4_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.Automatic = true;
                      firearm.AutomaticFireInterval = 0.09f;
                      firearm.barrelPosition = new Vector2(0.52f, 0.14f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/m4a1 sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "5,56×45mm NATO";
                      customCartridge.Damage = 15.8f;
                      customCartridge.Recoil = 0.64f;
                      customCartridge.ImpactForce = 0.042f;
                      customCartridge.StartSpeed = 12f;
                      customCartridge.PenetrationRandomAngleMultiplier = 0f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("auto shooting", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 15.8f;
                        customCartridge.Recoil = 0.64f;
                        customCartridge.ImpactForce = 0.042f;
                        customCartridge.StartSpeed = 12f;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 0.4f;
                        customCartridge.ImpactForce = 16f;
                        customCartridge.StartSpeed = 0.05f;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.078f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                  NameOverride = "SCAR-17 <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "To CS:GO Devs: \nI suggest YOU to make SCAR-17 like M4A1-S alt. (yeah, i am serious) \n<color=purple>(3 Skins)</color>\n <color=yellow>Ammo: 30/90",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/scar-17 icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var RifleSlide = Instance.transform.Find("Slide");
                      RifleSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Rifles/scar-17_slide.png", 2);
                      RifleSlide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Rifles/scar-17_collider.png", 22);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Rifles/scar-17.png", 2),
                          ModAPI.LoadSprite("Skins/SCAR-17Skins/scar-17 skin1.png", 8),
                          ModAPI.LoadSprite("Skins/SCAR-17Skins/scar-17 skin2.png", 8),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 30;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/scar-17_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.Automatic = true;
                      firearm.AutomaticFireInterval = 0.09f;
                      firearm.barrelPosition = new Vector2(0.54f, 0.12f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/scar-17 sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "5,56×45mm NATO";
                      customCartridge.Damage = 15.8f;
                      customCartridge.Recoil = 0.65f;
                      customCartridge.ImpactForce = 0.042f;
                      customCartridge.StartSpeed = 12f;
                      customCartridge.PenetrationRandomAngleMultiplier = 0f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("auto shooting", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 15.8f;
                        customCartridge.Recoil = 0.65f;
                        customCartridge.ImpactForce = 0.042f;
                        customCartridge.StartSpeed = 12f;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 0.4f;
                        customCartridge.ImpactForce = 16f;
                        customCartridge.StartSpeed = 0.05f;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.086f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                  NameOverride = "SG553 <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "S - means Scope. \n<color=purple>(3 Skins)</color>\n <color=yellow>Ammo: 30/90",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/sg553 icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var RifleSlide = Instance.transform.Find("Slide");
                      RifleSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Rifles/sg553_slide.png", 2);
                      RifleSlide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Rifles/sg553_collider.png", 22);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Rifles/sg553.png", 2),
                          ModAPI.LoadSprite("Skins/SG553Skins/sg553 skin1.png", 8),
                          ModAPI.LoadSprite("Skins/SG553Skins/sg553 skin2.png", 8),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 30;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/sg553_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.Automatic = true;
                      firearm.AutomaticFireInterval = 0.11f;
                      firearm.barrelPosition = new Vector2(0.52f, 0.12f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/sg553 sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "5,56×45mm NATO";
                      customCartridge.Damage = 14.5f;
                      customCartridge.Recoil = 0.72f;
                      customCartridge.ImpactForce = 0.04f;
                      customCartridge.StartSpeed = 12f;
                      customCartridge.PenetrationRandomAngleMultiplier = 0f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("auto shooting", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 14.5f;
                        customCartridge.Recoil = 0.72f;
                        customCartridge.ImpactForce = 0.04f;
                        customCartridge.StartSpeed = 12f;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 0.4f;
                        customCartridge.ImpactForce = 16f;
                        customCartridge.StartSpeed = 0.05f;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.09f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                  NameOverride = "M249 <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "10 ammo / 10. \n<color=purple>(3 Skins)</color>\n <color=yellow>Ammo: 100/200",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/m249 icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var RifleSlide = Instance.transform.Find("Slide");
                      RifleSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Rifles/_slide.png", 2);
                      RifleSlide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Machine Guns/m249_collider.png", 22);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Machine Guns/m249.png", 2),
                          ModAPI.LoadSprite("Skins/M249Skins/m249 skin1.png", 8),
                          ModAPI.LoadSprite("Skins/M249Skins/m249 skin2.png", 8),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 100;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/m249_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.Automatic = true;
                      firearm.AutomaticFireInterval = 0.08f;
                      firearm.barrelPosition = new Vector2(0.59f, 0.12f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/m249 sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "5,56×45mm NATO";
                      customCartridge.Damage = 15.5f;
                      customCartridge.Recoil = 0.98f;
                      customCartridge.ImpactForce = 0.06f;
                      customCartridge.StartSpeed = 12f;
                      customCartridge.PenetrationRandomAngleMultiplier = 0f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("auto shooting", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 15.5f;
                        customCartridge.Recoil = 0.98f;
                        customCartridge.ImpactForce = 0.06f;
                        customCartridge.StartSpeed = 12f;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 0.98f;
                        customCartridge.ImpactForce = 16f;
                        customCartridge.StartSpeed = 0.05f;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.19f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                  NameOverride = "Negev <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "If a machine gun costs cheaper than a rifle it is Israel one. \n<color=purple>(2 Skins)</color>\n <color=yellow>Ammo: 150/200",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Guns"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/negev icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var RifleSlide = Instance.transform.Find("Slide");
                      RifleSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Rifles/_slide.png", 2);
                      RifleSlide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Machine Guns/negev_collider.png", 22);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                      {
                          ModAPI.LoadSprite("Machine Guns/negev.png", 2),
                          ModAPI.LoadSprite("Skins/NegevSkins/negev skin1.png", 8),
                      };

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 150;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/negev_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.Automatic = true;
                      firearm.AutomaticFireInterval = 0.075f;
                      firearm.barrelPosition = new Vector2(0.61f, 0.16f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/negev sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "5,56×45mm NATO";
                      customCartridge.Damage = 16.9f;
                      customCartridge.Recoil = 1.06f;
                      customCartridge.ImpactForce = 0.06f;
                      customCartridge.StartSpeed = 12f;
                      customCartridge.PenetrationRandomAngleMultiplier = 0f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("auto shooting", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 16.9f;
                        customCartridge.Recoil = 1.06f;
                        customCartridge.ImpactForce = 0.06f;
                        customCartridge.StartSpeed = 12f;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                        ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 0.0f;
                        customCartridge.Recoil = 1.06f;
                        customCartridge.ImpactForce = 16f;
                        customCartridge.StartSpeed = 0.05f;
                      })
                      }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.176f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Rod"),
                  NameOverride = "Kevlar Vest & Helmet",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Even an ak-47 bullet will stop. I do not advise you to get used to it because it does not protect against damage.",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Specials"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/kevlar_vest icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Special/kevlar_vest1.png");

                      int PartCount = 3;

                      if (!Instance.GetComponent<ArmorBehaviour>())
                          Instance.AddComponent<ArmorBehaviour>();

                      ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                      ArmorProperties prop = new ArmorProperties();
                      Vector3 offset = new Vector3(.025f, 0);
                      Vector3 scaleOffset = new Vector3(.01f, .01f);

                      prop.armorPiece = "UpperBody";
                      prop.armorTier = 4;
                    prop.sprite = ModAPI.LoadSprite("Special/kevlar_vest1.png");
                      prop.offset = offset;
                      prop.scaleOffset = scaleOffset;
                      prop.armorPoints = 999999;

                      armor.prop = prop;
                      armor.SetProperties();

                      ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                      armProp[0].sprite = ModAPI.LoadSprite("Special/kevlar_vest2.png");
                      armProp[0].armorPiece = "MiddleBody";
                      armProp[0].offset = offset;
                      armProp[0].armorTier = 4;
                      armProp[0].scaleOffset = scaleOffset;
                      armProp[0].armorPoints = 999999;

                      armProp[1].sprite = ModAPI.LoadSprite("Special/kevlar_helmet.png");
                      armProp[1].armorPiece = "Head";
                      armProp[1].armorTier = 4;
                      armProp[1].scaleOffset = new Vector3(.075f, .075f);
                      armProp[1].armorPoints = 999999;
                      Vector2[] points = new Vector2[6];
                      points[0] = new Vector3(-.2f, .2f);
                      points[1] = new Vector3(-.2f, -.2f);
                      points[2] = new Vector3(.03f, -.2f);
                      points[3] = new Vector3(.03f, .06f);
                      points[4] = new Vector3(.2f, .06f);
                      points[5] = new Vector3(.2f, .2f);
                      armProp[1].customCollider = true;
                      armProp[1].points = points;

                      if (armor.spawn)
                      {
                          armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                          armor.SpawnOtherParts(armProp);
                      }

                      Instance.FixColliders();
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Sticky Grenade"),
                  NameOverride = "C4 <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "10 seconds & Terrorists win.",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Specials"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/c4 icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      Instance.AddComponent<StickyBehaviour>();
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Explosives/c4.png", 2f);
                      Instance.GetComponent<ExplosiveBehaviour>().FragmentForce = 25f;
                      Instance.GetComponent<ExplosiveBehaviour>().Range = 10f;
                      Instance.GetComponent<ExplosiveBehaviour>().Delay = 10f;
          						Instance.GetComponent<ExplosiveBehaviour>().ShockwaveStrength = 100f;
                      foreach (var c in Instance.GetComponents<AudioSource>())
                      {
                          GameObject.Destroy(c);
          						}
                      Instance.FixColliders();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.4f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Siren"),
                  NameOverride = "Decoy Grenade <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Simulates the firing sounds of the most powerful weapons. Before activation, press the buttons in the menu.",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Specials"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/fake_grenade icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Explosives/fake_grenade.png", 2f);
                      Instance.FixColliders();

                      SirenBehaviour sirenBehaviour = Instance.GetComponent<SirenBehaviour>();
                      sirenBehaviour.enabled = false;

                      UniversalSirenBehaviour behaviour = Instance.AddComponent<UniversalSirenBehaviour>() as UniversalSirenBehaviour;
                      behaviour.damagableMachineryBehaviour = sirenBehaviour.DamagableMachineryBehaviour;
                      behaviour.audioSource = sirenBehaviour.AudioSource;
                      behaviour.audioSource.loop = true;
                      behaviour.sounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/negev sound.mp3"),
                            ModAPI.LoadSound("Sounds/m249 sound.mp3"),
                            ModAPI.LoadSound("Sounds/ak-47 sound.mp3"),
                            ModAPI.LoadSound("Sounds/famas sound.mp3"),
                            ModAPI.LoadSound("Sounds/g3sg1 sound.mp3"),
                            ModAPI.LoadSound("Sounds/scar-20 sound.mp3"),
                            ModAPI.LoadSound("Sounds/ssg08 sound.mp3"),
                            ModAPI.LoadSound("Sounds/awp sound.mp3"),
                            ModAPI.LoadSound("Sounds/deagle sound.mp3"),
                            ModAPI.LoadSound("Sounds/r8 sound.mp3"),
                      };

                      var physicals = Instance.GetComponentsInChildren<PhysicalBehaviour>();

                      foreach (var physical in physicals)
                      {
                          physical.ContextMenuOptions.Buttons.Add
                          (
                              new ContextMenuButton("nextSound", "<color=green>Next sound", "<color=green>Switch to next sounds", () =>
                              {
                                  behaviour.ChangeSound(true);
                              })
                          );

                          physical.ContextMenuOptions.Buttons.Add
                          (
                              new ContextMenuButton("previousSound", "<color=red>Previous sound", "<color=red>Switch to previous sounds", () =>
                              {
                                  behaviour.ChangeSound(false);
                              })
                          );
                      }

                      UnityEngine.Object.Destroy(sirenBehaviour);
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.05f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Handgrenade"),
                  NameOverride = "Incendiary Grenade <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Time to ignite! The coolest grenade.",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Specials"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/fire_grenade icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Explosives/fire_grenade.png", 2.4f);
                      Instance.GetComponent<ExplosiveBehaviour>().Range = 10f;
                      Instance.GetComponent<ExplosiveBehaviour>().Delay = 2.5f;
          						Instance.GetComponent<ExplosiveBehaviour>().ShockwaveStrength = 0f;
          						Instance.GetComponent<ExplosiveBehaviour>().FragmentationRayCount = 0U;
          						Instance.GetComponent<ExplosiveBehaviour>().FragmentForce = 0f;
          						Instance.GetComponent<ExplosiveBehaviour>().BurnPower = 5f;
                      Instance.FixColliders();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Handgrenade"),
                  NameOverride = "Flashbang <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Dazzling...",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Specials"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/flashbang icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Explosives/flashbang.png", 2f);
                      Instance.AddComponent<UseEventTrigger>().Action = () =>
                      {
                      ModAPI.CreateParticleEffect("BigZap", Instance.transform.position);
                      };
                      Instance.GetComponent<ExplosiveBehaviour>().Range = 0f;
                      Instance.GetComponent<ExplosiveBehaviour>().Delay = 2f;
          						Instance.GetComponent<ExplosiveBehaviour>().ShockwaveStrength = 0f;
          						Instance.GetComponent<ExplosiveBehaviour>().FragmentationRayCount = 0U;
                      Instance.GetComponent<ExplosiveBehaviour>().FragmentForce = 0f;
                      Instance.FixColliders();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Handgrenade"),
                  NameOverride = "HE Grenade <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Like a regular grenade but HE.",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Specials"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/grenade icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Explosives/grenade.png", 2f);
                      Instance.GetComponent<ExplosiveBehaviour>().Range = 9f;
                      Instance.GetComponent<ExplosiveBehaviour>().Delay = 3f;
          						Instance.GetComponent<ExplosiveBehaviour>().ShockwaveStrength = 10f;
                      Instance.FixColliders();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Particle Projector"),
                  NameOverride = "Smoke Grenade <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "It good vapes and shows that SMOKING IS BAD!",
                  CategoryOverride = ModAPI.FindCategory("<color=#AE9D6A>CS</color>:<color=#5F7892>GO</color> Specials"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/smoke icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Explosives/smoke.png", 2.4f);
                      Instance.FixColliders();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                  }
              }
          );
        }
    }
}
